#include <QWidget>
#include <QLineEdit>
#include <QPushButton>
#include <QLabel>
#include <QString>
#include <QHBoxLayout>
#include <QApplication>
#include <qtextedit.h>
#include <QMessageBox>
#include "onewaylist.h"

using namespace std;
using namespace std::chrono;

class SortingApp : public QWidget {
public:
    SortingApp(QWidget *parent = nullptr) : QWidget(parent) {
        setupUI();
    }
private:
    QLineEdit *inputField;
    QTextEdit *outputField;
    QPushButton *testButton;
    OnewayList list;
    
    void setupUI() {
        QVBoxLayout *mainLayout = new QVBoxLayout(this);

        QLabel *label = new QLabel("Вводьте символи...", this);
        mainLayout->addWidget(label);

        inputField = new QLineEdit(this);
        inputField->setMaxLength(1);
        mainLayout->addWidget(inputField);
        
        QPushButton *sortButton = new QPushButton("Додати", this);
        QPushButton *findButton = new QPushButton("Знайти", this);
        testButton = new QPushButton("Перевірити об'єдання структур", this);
        testButton->setEnabled(false);
        connect(sortButton, &QPushButton::clicked, this, &SortingApp::onSortButtonClicked);
        connect(findButton, &QPushButton::clicked, this, &SortingApp::find);
        connect(testButton, &QPushButton::clicked, this, &SortingApp::test);
        QHBoxLayout *buttons = new QHBoxLayout();
        buttons->addWidget(sortButton);
        buttons->addWidget(findButton);
        buttons->addWidget(testButton);
        mainLayout->addLayout(buttons);

        outputField = new QTextEdit(this);
        outputField->setReadOnly(true);
        mainLayout->addWidget(outputField);

        setLayout(mainLayout);
        setWindowTitle("Робота зі списком");
        resize(500, 500);
    }
private slots:
    void onSortButtonClicked() {
      testButton->setEnabled(true);
list.append(inputField->text().toStdWString()[0]);
        inputField->clear();
        outputField->clear();
        std::wstring output;
        unsigned int i = 0;
        unsigned int counter = 0;
        wchar_t min=wchar_t(0xFFFF);
        wchar_t max=0;
        wchar_t third=wchar_t(0xFFFF);
        wchar_t secondfromend=wchar_t(0xFFFF);
        wchar_t premin=wchar_t(0xFFFF);
        wchar_t aftermax=wchar_t(0xFFFF);
        while (list.get(i,1)){
            counter++;
            if(counter==3)third=list.get(i);
            if(counter==2)secondfromend=list.get(0);else if (counter>2)secondfromend=list.get(i-2);
            output+=list.get(i);
            if (list.get(i)<min){min=list.get(i);if(counter>1)premin=list.get(i-1);}
            if (list.get(i)>max){max=list.get(i);aftermax=list.get(i+1,1);if(!aftermax){aftermax=0xFFFF;break;}}
            i++;
        }
        outputField->append("Всього елементів: " + QString::number(counter) + 
                            "\nМінімальний елемент: " + QString(QChar(min)) + 
                            "\nМаксимальний елемент: " + QString(QChar(max)) + 
                            "\nСписок: " + QString::fromStdWString(output) +
                            "\nПозиція останнього елементу: " + QString::number(counter-1));
    if (third!=wchar_t(0xFFFF))outputField->append("Третій з початку: "+QString(QChar(third)));
    if (secondfromend!=wchar_t(0xFFFF))outputField->append("Другий з кінця: "+QString(QChar(secondfromend)));
    if (premin!=wchar_t(0xFFFF))outputField->append("Елемент перед мінімальним: "+QString(QChar(premin)));
    if (aftermax!=wchar_t(0xFFFF))outputField->append("Елемент після максимального: "+QString(QChar(aftermax)));
    }
    void find() {
        int pos = list.find(inputField->text().toStdWString()[0], 1);
        if (pos == -1) QMessageBox::information(this,"Пошук елементу","Елемент не знайдено");
        else QMessageBox::information(this,"Пошук елементу","Елемент знайдено на позиції " + QString::number(pos));
        inputField->clear();
    }
    void test() {
      OnewayList list1;
      list1.append(L'a');
      list1.append(L'b');
      list1.append(L'c');
      QString output="Список 1: ";
      for (char i = 0; i < 3; i++) output += QChar(list1.get(i));
      output+="\nСписок 1 після додавання основного списку: ";
      unsigned int i=0;
      while (list.get(i,1)){
          list1.append(list.get(i));
          i++;
      }
      i=0;      
      while (list1.get(i,1)){
          output+=QChar(list1.get(i));
          i++;
      }
      QMessageBox::information(this,"Перевірка об'єднання структур",output);
    }
};

int main(int argc, char *argv[]) {
    QApplication app(argc, argv);
    SortingApp sortingApp;
    sortingApp.show();
    return app.exec();
}
